2010-07-27  Geoff Norton  <gnorton@novell.com>

	* mono-sigcontext.h: Extend the macro's for darwin and linux
	to expose r8-r11 as well.

2010-07-16 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.c: fixes bug #622398 for real in OSX.
	This was preventing the WSQ from working.

2010-07-02  Michael Hutchinson  <mhutchinson@novell.com>

	* mono-compiler.h: Add MONO_THREAD_VAR_OFFSET macro for s390x.

2010-07-02  Michael Hutchinson  <mhutchinson@novell.com>

	* Makefile.am: Add mono-error.h to public headers.
	* mono-error.h: Use public version of API.

Wed Jun 30 12:06:33 CEST 2010 Paolo Molaro <lupus@ximian.com>

	* mono-compiler.h: define MONO_LLVM_INTERNAL for internal functions
	that may be needed by the llvm backend module.

2010-06-25  Zoltan Varga  <vargaz@gmail.com>

	* gc_wrapper.h: Avoid redefining pthread_ calls for SGEN, no longer needed.

	* gc_wrapper.h: Define the mono_gc_ wrappers for Boehm too, runtime code should
	call these instead of the pthread_ variants.

2010-06-22  Geoff Norton  <gnorton@novell.com>

	* mach-support-arm.c: Add arm support.

2010-06-22 Geoff Norton  <gnorton@novell.com>

	* mach-support-*.(c|h): We cannot allocate from the gc, so make
	these functions alloc-less.

2010-06-22  Geoff Norton  <gnorton@novell.com>

	* Makefile.am
	* mach-support-amd64.c
	* mach-support-x86.c
	* mach-support.c
	* mach-support.h: Added a new suite of helpers for managing threads
	on mach based kernels.

2010-06-17  Geoff Norton  <gnorton@novell.com>

	* mono-sigcontext.h: Add arm variants.

2010-05-29  Marek Habersack  <mhabersack@novell.com>

	* mono-dl.c (mono_dl_build_path): modify the logic to try the
	use the passed name to build the path without suffix on the first
	run (handles situations like "somelib.so.1.0" ->
	"libsomelib.so.1.0") and, on subsequent run, append the platform
	suffix(es) (handles situations like "libsomething" ->
	"libsomething.so"). Fixes bugs #588143 and #610009

2010-06-01  Geoff Norton  <gnorton@novell.com>

	* mono-poll.c: poll() is broken on osx in several cases, so we use a select
	based mono_poll() instead.

2010-05-12  Zoltan Varga  <vargaz@gmail.com>

	* mono-sigcontext.h: Define UCONTEXT_REG_ constants for amd64 even if the gregs
	array is available.

2010-05-05 Jonathan Chambers <joncham@gmail.com>

	* mono-semaphore.c: Implement alertable wait on Windows similar to
	other platforms. Always be alertable, but only return from wait if
	user requested alertable state. Fixes soft debugger on Windows.

2010-04-23  Geoff Norton  <gnorton@novell.com>

	* mono-sigcontext.h: Darwin x86_64 support.

2010-04-09 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.c: account for the time already spent in wait if
	interrupted.

2010-04-09  Zoltan Varga  <vargaz@gmail.com>

	* mono-time.c (get_boot_time): Applied more openbsd changes from Robert Nagy
	<robert@openbsd.org>.

2010-04-09  Zoltan Varga  <vargaz@gmail.com>

	* mono-proclib.c: Applied more openbsd changes from Robert Nagy
	<robert@openbsd.org>.

2010-04-08 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.c: set EINTR on windows too.

2010-04-01 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.c: patch from Robert Nagy that makes this work in
	OpenBSD.

2010-04-01 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.[ch]: wait can be alertable now. Defaults to FALSE.

2010-04-01  Sebastien Pouliot  <sebastien@ximian.com>

	* mono-logger.c, mono-logger-internal.h: Add a new "security"
	category to logging infrastructure.

2010-03-31  Miguel de Icaza  <miguel@novell.com>

	* mono-semaphore.h: Use Windows semaphores on Windows, patch
	contributed by Vincent Povirk from bugzilla #531767

2010-03-31  Miguel de Icaza  <miguel@novell.com>

	* mono-hash.c (test_prime): Remove warnings

2010-03-27  Zoltan Varga  <vargaz@gmail.com>

	* mono-ehash.c: Rename this to mono-hash.c.

2010-03-26  Zoltan Varga  <vargaz@gmail.com>

	* mono-ehash.c (rehash): Avoid function calls as macro arguments.

Fri Mar 26 19:44:40 CET 2010 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, mono-hash.c: removed mono-hash.c, since now
	mono-ehash.c is GC-aware it doesn't make sense to keep two
	implementations.

2010-03-26  Mark Probst  <mark.probst@gmail.com>

	* mono-semaphore.h (MONO_SEM_POST): Fix on Darwin.

2010-03-26  Zoltan Varga  <vargaz@gmail.com>

	* mono-proclib.c mono-semaphore.c: Apply some openbsd changes from openbsd
	ports.

2010-03-25 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.[hc]: make sure the semaphore calls are restarted if
	interrupted. Return 0 on success and -1 on failure on windows.

2010-03-25  Mark Probst  <mark.probst@gmail.com>

	* mono-hash.c, mono-ehash.c: Fix rehashing with regard to moving
	GC.  Register root for ehash.

2010-03-24  Andrés G. Aragoneses  <knocte@gmail.com>

	* mono-dl.c: (mono_dl_build_path) Take in account the suffix
	variable assigned wrt the prefix comparison to concat the final
	path for dlopen. Fixes BNC#588143. r:vargaz

2010-03-23 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.h: MONO_SEM_WAIT() return value inverted when using
	the windows API.
	* mono-semaphore.c: handle INFINITE timeout.

2010-03-22  Zoltan Varga  <vargaz@gmail.com>

	* mono-sigcontext.h: Define UCONTEXT accessors for openbsd/amd64.

2010-03-22  Zoltan Varga  <vargaz@gmail.com>

	* mono-sigcontext.h: Applied patch from Robert Nagy (Robert@openbsd.org).
	Add OpenBSD definitions.

2010-03-17 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.c: _timedwait takes an absolute time.

2010-03-04  Zoltan Varga  <vargaz@gmail.com>

	* strtod.c: Get rid of locking so this works with eglib.

2010-03-03 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-mmap.c: apparently kill() can return ENOMEM. Also use signal 0
	which is the documented way of testing for the existence of a PID.
	Thanks to Cal Page.

Thu Feb 25 11:59:22 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mono-logger.h, Makefile.am: expose in the API the ability to
	set trace mask and level.
	* mono-logger-internal.h: new header for mono internal use.
	* mono-logger.c: fixed mono_trace_set_mask_string() to not change
	the passed string argument.

Wed Feb 24 15:50:55 CET 2010 Paolo Molaro <lupus@ximian.com>

	* mono-publib.h, mono-publib.c: new public header file to allow
	the removal of gli from the other public headers.
	* Makefile.am: install only the public header mono-publib.h.

2010-02-19 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.h: enable the #defines when io-layer is in use.
	* Makefile.am: added new file.
	* mono-semaphore.c: new mono_sem_timedwait() function.

2010-02-19 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-semaphore.h: set maximum count to 0x7fffffff.

2010-01-28 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-error-internals.h: Add mono_error_set_not_verifiable.

	* mono-error.h: Add MONO_ERROR_NOT_VERIFIABLE.

	* mono-error.c: Implement mono_error_set_not_verifiable.

2010-01-26  U-anarquia\miguel  <miguel@anarquia>

	* mono-dl.c: Removed debugging messages for the embeddable version
	of mono-dl.

2010-01-22 Miguel de Icaza (miguel@novell.com)

	* mono-dl.c: Always strdup the return value, for consistency.

2010-01-18  Sebastien Pouliot  <sebastien@ximian.com>

	* mono-error.c: Call va_end/va_start before reusing 'args'.

2010-01-15 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-hash.c: fix the null-gc build.

2010-01-11  Miguel de Icaza  <miguel@novell.com>

	* valgrind.h, memcheck.h: Add guards to prevent the gcc features
	from being included in non-GCC builds like the Windows build.

2010-01-03  Zoltan Varga  <vargaz@gmail.com>

	* mono-path.c (mono_path_resolve_symlinks): Use g_strfreev () to free the
	result of g_strplit.

2009-12-18  Zoltan Varga  <vargaz@gmail.com>

	* valgrind.h memcheck.h: New files containing the BSD licensed valgrind
	headers so we can use the valgrind user requests even if mono is compiled on
	a system where they are not installed.

2009-12-11  Marek Habersack  <mhabersack@novell.com>

	* mono-io-portability.c: moved all the reporting code to the IOMAP
	profiler module.
	(mono_portability_find_file_internal): calls mono_profiler_iomap
	whenever an adjustement is made.

2009-12-02  Mark Probst  <mark.probst@gmail.com>

	* mono-hash.c: Don't use MONO_ROOT_SETREF for setting keys and
	values.  It's unnecessary - the hash table has a marking function
	which takes care of all GC-tracked keys and values.

2009-11-26  Zoltan Varga  <vargaz@gmail.com>

	* mono-ehash.c (mono_g_hash_table_find): Add this for eglib too.

2009-11-25 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-error-internals.h: Add mono_error_set_bad_image_name and change signature
	of mono_error_set_bad_image to take a MonoImage instead of a const char *.

	* mono-error.c: Same.

2009-11-25  Zoltan Varga  <vargaz@gmail.com>

	* mono-hash.c (mono_g_hash_table_find): Implement this.

2009-11-24  Zoltan Varga  <vargaz@gmail.com>

	* mono-io-portability.c (append_report): g_string_append_vprintf is available
	only in glib 2.14.

2009-11-23  Andreas Färber  <andreas.faerber@web.de>

	* mono-mmap.c (mono_mprotect): Use posix_madvise in absence of madvise.
	
	Code contributed under MIT/X11 license.

2009-11-23  Marek Habersack  <mhabersack@novell.com>

	* mono-io-portability.c: gather up and report misnamed files
	accessed by the application if the 'report' option is present in
	the MONO_IOMAP environment variable.

2009-11-13 Jonathan Chambers <joncham@gmail.com>

	* mono-semaphore.h: Implementation for Windows platform.

	Code contributed under MIT/X11 license.

2009-11-12  Geoff Norton  <gnorton@novell.com>

	* mono-path.c: When resolving symlinks in a path, we need to
	split on the directory separator and check each level, as
	readlink only checks the final destination.

2009-11-08  Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-sigcontext.h: Add ucontext support for FreeBSD/ppc64.

	Patch by Justin Hibbits <chmeeedalf@gmail.com>.

2009-11-06 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-error.c: VS does not like this.

2009-11-05 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-error-internals.h: Add mono_error_set_argument and mono_error_raise_exception.

	* mono-error.h: Add new MONO_ERROR_ARGUMENT constant for
	ArgumentException.

	* mono-error.c: Implement mono_error_set_argument, mono_error_raise_exception.

 	* mono-error.c (mono_error_prepare_exception) Init error_out at the beginning. Add support
	for MONO_ERROR_ARGUMENT.

2009-10-30 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-proclib.c: hz is only multiplied by the number of cpus when
	requesting "_Total".

2009-10-29  Mark Probst  <mark.probst@gmail.com>

	* mono-hash.c (mono_g_hash_mark): Don't use SET_NODE_KEY/VALUE here.

2009-10-23  Alp Toker  <alp@nuanti.com>

	Fix embedding API breakage from r144688. mono-compiler.h is an internal
	header and should not be shipped:

	* Makefile.am: Include newly added public header mono-error.h in HEADERS so
	it gets installed.

2009-10-23 Rodrigo Kumpera  <rkumpera@novell.com>

	* Makefile.am: Fix make dist.

2009-10-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-compiler.h: Add MONO_DEPRECATED.

2009-10-22 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-error.c, mono-error.h, mono-error-internal.h: New error handling
	structures and functions.

	* Makefile.am: Add new files.

2009-10-12  Joel W. Reed <joelwreed@gmail.com>

	* mono-networkinterfaces.c, mono-networkinterfaces.h: Read
	network statistics from "/proc/net/dev" for performance counters.

	Code is contributed under MIT/X11 license.

2009-09-29  Zoltan Varga  <vargaz@gmail.com>

	* mono-compiler.h (MONO_INTERNAL): Disable this on solaris as it produces a
	millions of warnings during compilation.

2009-09-25  Jonathan Chambers  <joncham@gmail.com>

	* mono-logger.c: Include mono-compiler.h for __func__ on MSVC.

	Code is contributed under MIT/X11 license.

2009-09-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-sha1.c: Update documentation.

2009-09-02 Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-md5.c: Update documentation.

2009-09-02  Sebastien Pouliot  <sebastien@ximian.com>

	* mono-dl.c (mono_dl_open): Don't leak module if name is NULL
	* mono-md5.c (mono_md5_get_digest_from_file): Close 'fp' even on
	success (just like we do for sha1)

2009-08-21  Mark Probst  <mark.probst@gmail.com>

	* mono-hash.c: When creating a hash table, if the keys are managed
	objects, assert that we have a hash function.  Remove the
	rehashing after GC marking.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* strtod.c: Fix warnings for uninitialized variables.

2009-08-18  Christian Hergert  <chris@dronelabs.com>

	* mono-proclib.c:
	* mono-counters.c: Fix printf warnings.

2009-08-12  Mark Probst  <mark.probst@gmail.com>

	* mono-hash.c (mono_g_hash_mark): If the keys are managed objects,
	rehash the table after marking.

2009-08-10 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* monobitset.h: add comment.

2009-08-01  Zoltan Varga  <vargaz@gmail.com>

	* mono-sigcontext.h (UCONTEXT_GREGS): Fix freebsd definition.

2009-07-30  Mark Probst  <mark.probst@gmail.com>

	* mono-sigcontext.h: Include config.h.

2009-07-30  Mark Probst  <mark.probst@gmail.com>

	* mono-sigcontext.h, Makefile.am: Arch-dependent sigcontext
	macros, moved from mini.

2009-07-29  Massimiliano Mantione  <massi@ximian.com>

	* mono-codeman.c (free_chunklist and new_codechunk):
	Call profiler hooks to keep track of code chunks.

2009-07-20  Geoff Norton  <gnorton@novell.com>

	* mono-semaphore.h: Refactor from io-layer/thread-private.h so it
	can be used by the runtime as well.

2009-07-17 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-proclib.c: fix reading processor usage for a process. Patch
	from Jacob Gladish that fixes bug #523052.

2009-07-15 Gonzalo Paniagua Javier <gonzalo@novell.com>

	* mono-proclib.c: fixed setting the NUL terminator.
	Thanks to Jacob Gladish.

2009-06-15  Zoltan Varga  <vargaz@gmail.com>

	* gc_wrapper.h: Disable thread local alloc on mips.

2009-05-26  Zoltan Varga  <vargaz@gmail.com>

	* CMakeLists.txt: New file.

2009-05-09  Miguel de Icaza  <miguel@novell.com>

	* mono-value-hash.c (mono_value_hash_table_insert_replace):
	Initialize variable, to quiet the compiler. 

	* mono-proclib.c: Eliminate two warnings.

2009-04-03  Miguel de Icaza  <miguel@novell.com>

	* mono-filemap.c: Move mono_file_unmap for the not-mmap case to
	the mono-filemap.c file so it can be plugged in platform-specific
	code as well. 

2009-04-03 Rodrigo Kumpera  <rkumpera@novell.com>

	* strenc.h:
	* strenc.c: Add mono_utf8_validate_and_len_with_bounds.

2009-03-23  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (libmonoutils_la_SOURCES): Fix make dist.

2009-03-22  Zoltan Varga  <vargaz@gmail.com>

	* gc_wrapper.h: Disable thread local allocation for ARM too because of
	incomplete support in libgc.

2009-03-20  Zoltan Varga  <vargaz@gmail.com>

	* gc_wrapper.h: New file, moved from ../os.

	* Makefile.am: Add gc_wrapper.h

2009-03-06  Zoltan Varga  <vargaz@gmail.com>

	* mono-hash.c: Use precise GC allocation for the Boehm GC as well.

2009-02-16  Mark Probst  <mark.probst@gmail.com>

	Contributed under the terms of the MIT/X11 license by Steven
	Munroe <munroesj@us.ibm.com>.

	* mono-compiler.h: MONO_THREAD_VAR_OFFSET for PPC(64).

2009-02-11  Bill Holmes  <billholmes54@gmail.com>

	* mono-filemap.c : Fixing the MSVC build.

	Contributed under MIT/X11 license.

2009-02-03  Miguel de Icaza  <miguel@novell.com>

	* mono-dl.c: Add support for registering in-proc addresses as
	libraries that can be P/Invoked.   Used in operating systems that
	lack a dynamic linker. 

	* mono-filemap.c: Integrate Paolo's mono-filemap code here, split
	some code from mono-mmap. into this file to ease porting.

	* mono-io-portability.c: Use new define to turn off portability
	features. 

2009-01-25  Zoltan Varga  <vargaz@gmail.com>

	* mono-compiler.h (MONO_THREAD_VAR_OFFSET): Add ARM Linux support.

2009-01-21  Zoltan Varga  <vargaz@gmail.com>

	* mono-mmap.c: Applied patch from Koushik Dutta
	(koush@koushikdutta.com). Rework the #ifdefs so Android could use the mmap
	implementation.

2009-01-19  Bill Holmes  <billholmes54@gmail.com>

	* mono-path.c (mono_path_canonicalize): Adding support for UNC
	   paths on Windows.

	Contributed under MIT/X11 license.

2009-01-18  Zoltan Varga  <vargaz@gmail.com>

	* mono-mmap.c: Applied patch from Koushik Dutta
	(koush@koushikdutta.com). Add an #ifdef HAVE_SHM_OPEN.

2009-01-16  Zoltan Varga  <vargaz@gmail.com>

	* mono-hash.c: Change the roots to use write barriers when running with
	SGEN, to avoid scanning all the hash nodes at every minor collection.

2009-01-15  Zoltan Varga  <vargaz@gmail.com>

	* mono-hash.c: Rewrite the SGEN specific parts to use a user defined
	marker function instead of registering each GC node as a hash root.

2009-01-08  Bill Holmes  <billholmes54@gmail.com>

	* mono-dl.c (mono_dl_open): Fix the MSVC build.

	Contributed under MIT/X11 license.

2008-12-19  Miguel de Icaza  <miguel@novell.com>

	* mono-dl.c (mono_dl_open): Do not crash if the platform does not
	support dlopen.

2008-12-08  Kornél Pál  <kornelpal@gmail.com>

	* mono-time.c (mono_100ns_ticks, PLATFORM_WIN32): Use GetSystemTimeAsFileTime
	with ULARGE_INTEGER that is more efficient.

	Contributed under MIT/X11 license.

2008-12-02  Rodrigo Kumpera  <rkumpera@novell.com>

	* mono-property-hash.c (mono_property_hash_destroy): Release
	the root hashtable as well.

2008-11-24  Zoltan Varga  <vargaz@gmail.com>

	* freebsd-elf_common.h (struct): Use uint32_t instead of 
	u_int32_t to fix the build on opensolaris.

2008-11-18  Zoltan Varga  <vargaz@gmail.com>

	* freebsd-dwarf.h: Add dwarf.h header file from freebsd.

2008-11-14  Andreas Färber  <andreas.faerber@web.de>

	* Makefile.am (ENABLE_DTRACE): Re-add dtrace -h flag.
	Fixes #445074.
	
	Contributed under MIT/X11 license.

Mon Nov 10 17:38:41 CET 2008 Paolo Molaro <lupus@ximian.com>

	* mono-proclib.c: adapt code for FreeBSD and hopefully other BSD
	systems.

Mon Nov 10 17:27:01 CET 2008 Paolo Molaro <lupus@ximian.com>

	* mono-proclib.c, mono-proclib.h: added elapsed time and parent pid.

2008-11-05  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (libmonoutils_la_SOURCES): Add the freebsd-elf*.h files to
	the build.

2008-11-04  Zoltan Varga  <vargaz@gmail.com>

	* freebsd-elf32.h freebsd-elf64.h freebsd-elf_common.h: Add elf header
	files from freebsd.

Wed Oct 22 17:43:03 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* mono-proclib.c, mono-proclib.h: added functions to get info
	about the processors in the system.

Wed Oct 22 16:45:20 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* mono-proclib.c, mono-mmap.c: basic support for OSX and
	(untested) BSD systems.

2008-10-13  Bill Holmes  <billholmes54@gmail.com>

	* mono-proclib.c : Adding a compilation check for HAVE_UNISTD_H.

	Contributed under MIT/X11 license.

Mon Oct 13 14:36:10 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* mono-proclib.c, mono-proclib.h: added a function to deal with
	error handling if the caller needs the info.

Mon Oct 13 11:11:43 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, mono-proclib.c, mono-proclib.h: utility functions to
	access process-related information.

2008-10-08  Zoltan Varga  <vargaz@gmail.com>

	* mono-compiler.h (MONO_THREAD_VAR_OFFSET): Apply a patch from
	the fedora packagers to the IA64 MONO_THREAD_VAR_OFFSET definition.

2008-09-26  Zoltan Varga  <vargaz@gmail.com>

	* mono-mmap.c (mono_shared_area_for_pid): Fix a warning.

Thu Sep 18 18:16:45 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* mono-mmap.c, mono-mmap.h: added mono_shared_area_instances ()
	too return the list of mono processes with performance counter data.

2008-08-27  Bill Holmes  <billholmes54@gmail.com>

	* strenc.c : Fixing some waringings and compiler errors when using
	  eglib.

	Contributed under MIT/X11 license.

2008-08-20  Mike Voorhees  <vernish13@gmail.com>

	* strenc.h : Adding declaration for mono_utf8_validate_and_len.

	* strenc.c : Adding implementation for mono_utf8_validate_and_len.

	Contributed under MIT/X11 license.

2008-08-03  Andreas Färber  <andreas.faerber@web.de>

	* mono-io-portability.c (mono_portability_find_file): Fix ANSI C compliance.
	
	Contributed under MIT/X11 license.

Fri Aug 1 15:48:53 CEST 2008 Paolo Molaro <lupus@ximian.com>

	* mono-mmap.h, mono-mmap.c: added support for storing some runtime data
	in a shared memory page.

2008-07-21  Bill Holmes  <billholmes54@gmail.com>

	* mono-membar.h :  From previous commit.  When including glib.h,
 	  <> should be used and not "".

	Contributed under MIT/X11 license.

2008-07-21  Bill Holmes  <billholmes54@gmail.com>

	* mono-membar.h :  Including glib.h to get definition of 'inline.'  Needed
	  by the MSVC compiler.

	Contributed under MIT/X11 license.

2008-07-09  Zoltan Varga  <vargaz@gmail.com>

	* mono-codeman.c (mono_code_manager_new): Initialize the read-only field.
	
	* mono-codeman.c (mono_code_manager_set_read_only): New helper function to
	set the code manager to read-only status.
	(mono_code_manager_reserve_align): Assert if the code manager is read only.

2008-06-14  Zoltan Varga  <vargaz@gmail.com>

	* mono-codeman.c (new_codechunk): Allocate memory for dynamic code managers
	using dlmemalign.

	* dlmalloc.c: Enable the memalign functions.

2008-06-05  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (libmonoutils_la_SOURCES): Add dtrace.h.

2008-06-05  Andreas Färber  <andreas.faerber@web.de>

	* dtrace.h: New file, defines macros for DTrace probes.
	* Makefile.am (BUILT_SOURCES): Generate mono-dtrace.h when DTrace enabled.

	Contributed under MIT/X11 license.

2008-05-29  Zoltan Varga  <vargaz@gmail.com>

	* mono-value-hash.c: Remove the unused prime functions. Fixes #395320.

2008-05-27  Zoltan Varga  <vargaz@gmail.com>

	* mono-value-hash.c: Fix build on older glib versions.

	* Makefile.am (libmonoutils_la_SOURCES): Add mono-value-hash.{h,c}.

	* mono-value-hash.h mono-value-hash.c: New files.

2008-05-26  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (libmonoutils_la_SOURCES): Add mono-property-hash.{h,c}.

	* mono-property-hash.h mono-property-hash.c: New files.

2008-05-14  Kornél Pál  <kornelpal@gmail.com>

	* mono-path.c (mono_path_canonicalize): Convert '/' to '\' on Windows that
	fixes path canonicalization for paths containing '/'.

	Contributed under MIT/X11 license.

2008-05-04  Andreas Faerber  <andreas.faerber@web.de>

	* mono-membar.h: Prepare support for OSX/ppc64.

	Contributed under MIT/X11 license.

2008-04-16  Jonathan Chambers  <joncham@gmail.com>
	* monobitset.c (find_first_unset): Use gsize instead of gulong for platform
	  dependent size; fixes Win64.
	* mono-member.h: Implement mono_memory_barrier, mono_memory_read_barrier, and 
	  mono_memory_write_barrier for Win64.

	Contributed under MIT/X11 license.

2008-04-16  Marek Habersack  <mhabersack@novell.com>

	* mono-io-portability.c (mono_portability_find_file): properly
	process unrooted entries with a trailing slash.

2008-04-09  Zoltan Varga  <vargaz@gmail.com>

	* dlmalloc.h dlmalloc.c: New files, a slightly modified version of Doug
	Lea's malloc package.

	* mono-codeman.c: Use dlmalloc for managing memory in dynamic code managers,
	this allows us to set the executable bit on the system memory dlmalloc 
	allocates from, fixing #320036.

2008-03-29  Zoltan Varga  <vargaz@gmail.com>

	* mono-logger.h: Move G_END_DECLS outside of an #ifdef. Fixes #375107.

2008-03-14  Robert Jordan  <robertj@gmx.net>

	* mono-dl.c (w32_load_module): prevent error dialog by resetting
	the Win32 error mode during LoadLibrary (). Fixes #360363.

	* mono-dl.c (w32_dlerror): kill a warning.

2007-MM-DD  Yoichi NAKAYAMA  <nakayama@pixela.co.jp>
 
 	* mono-membar.h: Memory barrier for mips.
 
 	Contributed under MIT/X11 license.
 
Tue Feb 26 15:43:26 CET 2008 Paolo Molaro <lupus@ximian.com>

	* mono-time.c, mono-time.h: new file with the implementation of the
	time-related routines we need in mono. This includes a hires
	monotonic clock and a proper monotonic replacement for GetTickCount ().

2008-02-13  Zoltan Varga  <vargaz@gmail.com>

	* mono-membar.h (mono_memory_barrier): Applied patch by Sergey Tikhonov 
	<tsv@solvo.ru>. Add alpha support.

2008-01-11  Zoltan Varga  <vargaz@gmail.com>

	* mono-io-portability.c: Include errno.h since it is needed by code inside
	#ifdef DEBUG.

	* mono-ehash.c: Don't include os/gc_wrapper.h.

2008-01-06  Zoltan Varga  <vargaz@gmail.com>

	* mono-hash.c: Don't include os/gc_wrapper.h.

2007-11-06  Geoff Norton  <gnorton@novell.com>

	* strtod.c: Use a G_MUTEX call pattern compatible with eglib.  Patch
	from Jonathan Chambers

2007-10-11  Zoltan Varga  <vargaz@freemail.hu>

	* mono-mmap.c (mono_vfree): Fix call to VirtualFree (). Fixes #332165.

Mon Oct 8 11:47:44 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c, mono-codeman.h: added a function to be able
	to specify alignment per-allocation. Changed the code to align
	the starting position instead of the size, which wouldn't work
	with variable-alignment.

Mon Oct 8 10:51:29 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c, mono-codeman.h: fixed alignment code to not
	be wasteful, Added documentation. Added mono_code_manager_size ()
	to gather statistics info about a code manager.

Mon Oct 8 10:21:47 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mono-counters.h, mono-counters.c: better formatting of the output
	and added a cleanup function.

2007-10-03  Miguel de Icaza  <miguel@novell.com>

	* mono-compiler.h (trunc): Make the definition of trunk for MSC
	use ceil or floor instead of always using floor which is
	incorrect.

	Issue pointed out by Aras Pranckevicius <aras@unity3d.com>

2007-10-02  Jonathan Chambers <joncham@gmail.com>

	* mono-io-portability.c: Init __mono_io_portability_helpers
	to PORTABILITY_NONE on windows as mono_portability_helpers_init
	is not always called before mono_portability_find_file.
	
	Code is contributed under MIT/X11 license.

2007-10-01  Jonathan Chambers <joncham@gmail.com>

	* mono-io-portability.c: Only support on non-Windows
	platforms.
	
	Code is contributed under MIT/X11 license.

Mon Sep 24 17:14:05 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* strtod.h, strtod.c: made the code threadsafe, fixed gcc warnings,
	renamed exported call and made it properly internal.

2007-09-14  Jonathan Chambers <joncham@gmail.com>

	* mono-io-portability.c: Add HAVE_UNISTD_H check around include.
	
	Code is contributed under MIT/X11 license.

Wed Sep 12 15:15:47 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: don't install internal headers.

2007-09-12  Marek Habersack  <mhabersack@novell.com>

	* mono-io-portability.c: added. Moved options_init from io-layer.
	(find_in_dir): moved from io-layer/io-portability.c
	(mono_portability_find_file): moved find_file from
	io-layer/io-portability.c, renamed and made MONO_INTERNAL.

	* mono-io-portability.h: added. Contains declarations utility
	functions and acros for checking whether MONO_IOMAP is in effect.
	Added a prototype for mono_portability_find_file.

2007-09-09  Zoltan Varga  <vargaz@gmail.com>

	* mono-compiler.h: Applied patch from Jurek Bartuszek (jurek@gentoo.org).
	Fixes build with -fPIE.

2007-08-31  Jonathan Chambers <joncham@gmail.com>

	* mono-compiler.h: Define MONO_INTERNAL to nothing on Windows.
	Fixes tons of warnings we get on cygwin build.
	
	Code is contributed under MIT/X11 license.

2007-08-14  Jonathan Chambers <joncham@gmail.com>

	* mono-membar.h: Use intrinsic functions in msvc.

2007-07-31  Zoltan Varga  <vargaz@freemail.hu>

	* mono-dl.c (w32_dlerror): Fix call to FormatMessage (). Fixes #82260.

2007-07-27  Mark Probst  <mark.probst@gmail.com>

	* mono-membar.h: Memory barriers.

2007-06-13  Mark Probst  <mark.probst@gmail.com>

	* mono-codeman.c (mono_code_manager_reserve): Gather dynamic code
	allocation stats.

2007-06-06  Mark Probst  <mark.probst@gmail.com>

	* mono-internal-hash.c: Fixed a bug in the remove entry code.

2007-06-04  Mark Probst  <mark.probst@gmail.com>

	* Makefile.am:
	* mono-internal-hash.c, mono-internal-hash.h: Hash table which
	uses the value themselves as nodes, hence doesn't have to allocate
	nodes.

2007-05-24  Jonathan Chambers  <joncham@gmail.com>

	* mono-path.c: Add configure checks for header files.
	* mono-codeman.c: Add configure checks for header files.
	* mono-poll.h: Add configure checks for header files.
	* mono-stdlib.c: Add configure checks for header files.
	
	Code is contributed under MIT/X11 license.

2007-03-09  Jonathan Chambers  <joncham@gmail.com>

	* mono-dl.c:  Use Unicode characters for Win32 functions.
	
	Code is contributed under MIT/X11 license.
        
2007-01-26  Robert Jordan  <robertj@gmx.net>

	* mono-dl.c (w32_find_symbol): Implement in-proc symbol lookup
	for Win32.

Fri Jan 26 13:06:57 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mono-dl.h, mono-dl.c: make symbols internal and fixes.

Wed Jan 24 23:20:17 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c: don't call mono_mprotect() on windows.

2007-01-20  Zoltan Varga  <vargaz@gmail.com>

	* monobitset.h: monobitset.c: Move MonoBitSet type definition to
	the header file. Add fast macro based versions of most bitset 
	operations and optimize the rest a bit.

Mon Dec 18 18:59:08 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-dl.h, mono-dl.c, Makefile.am: implementation
	of dynamic loading API.

Wed Dec 13 17:21:40 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-mmap.c, mono-mmap.h: use guint64 instead of off_t.

2006-12-12  Atsushi Enomoto  <atsushi@ximian.com>

	* mono-mmap.c : win32 build fix.

Mon Dec 11 17:24:49 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c: changed to use the mono-mmap.h API.

Mon Dec 11 15:08:27 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-mmap.c, mono-mmap.h, Makefile.am: introduced mmap-like API.

Mon Nov 27 16:03:58 CET 2006 Paolo Molaro <lupus@ximian.com>

	* strtod.c: fix, again, 64 bit issues.

2006-11-25  Miguel de Icaza  <miguel@novell.com>

	* strtod.c: Upgrade this implementation to the one from:
	http://www.netlib.org/fp/

	Fixed a few warnings, and added the header thta we had to
	autodetect the FPU setup to use.

	This should fix the hang when running the corlib test suite. 

2006-10-18  Miguel de Icaza  <miguel@novell.com>

	* mono-ehash.c (mono_g_hash_table_destroy): Use mg_free, not
	g_free. 

2006-10-17  Miguel de Icaza  <miguel@novell.com>

	* mono-ehash.c: Use the new eglib hash implementation;   Currently
	only Boehm is supported. 

Tue Oct 10 09:53:07 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* strtod.c: teleport to the new millennium.

2006-10-09  Miguel de Icaza  <miguel@novell.com>

	* strtod.c: Replace the BSD implementation which was fairly old
	and complex with a cleaner version from Tcl/Tk.   Fixes the hang
	that we have in the Double parsing tests in our class libraries.

2006-09-12  Zoltan Varga  <vargaz@gmail.com>

	* strtod.c (IEEE_8087): Applied patch from Sergey Tikhonov <tsv@solvo.ru>. Define
	IEEE_8087 for alpha as well.

2006-09-04  Robert Jordan  <robertj@gmx.net>

	* mono-stdlib.c (mono_mkstemp): Fix mkstemp's loop.

2006-08-30  Zoltan Varga  <vargaz@gmail.com>

	* mono-codeman.c: Align code to a 16 byte boundary on amd64 too.

2006-08-23 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Makefile.am:
	* mono-stdlib.[ch]: mkstemp implementation.

2006-08-22 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Makefile.am:
	* mono-path.[ch]: new files with functions to handle/resolve paths.

2006-08-10  Zoltan Varga  <vargaz@gmail.com>

	* mono-compiler.h: Fix TLS definitions so libmono can be loaded dynamically as a
	module. Fixes #78767.

Wed May 17 19:00:15 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mono-hash.h, mono-hash.c: changed the code so we're able to
	specify if the key or value or both are managed objects.

2006-04-10  Zoltan Varga  <vargaz@gmail.com>

	* monobitset.c (mono_bitset_sub): Use src->size since the assert 
	guarantees it is less than dest->size.

Mon Apr 10 12:28:05 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* monobitset.c: cap size in mono_bitset_sub () to
	avoid reading uninit memory.

Wed Mar 29 16:39:14 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mono-counters.c: initialize the next pointer.

Mon Mar 20 14:50:35 CET 2006 Paolo Molaro <lupus@ximian.com>

	* monobitset.c, monobitset.h: added mono_bitset_find_first_unset ().

2006-03-16  Zoltan Varga  <vargaz@gmail.com>

	* monobitset.c: Guard inline asm with #ifdef __GNUC__.

	* monobitset.c (mono_bitset_find_first): Turn a g_return_val_if_fail
	into an assert.

	* mono-compiler.h (MONO_INTERNAL): Disable this on the VC build.

2006-03-10  Zoltan Varga  <vargaz@gmail.com>

	* monobitset.h monobitset.c: Merge lots of optimizations from the linear-il 
	branch.

2006-03-01  Zoltan Varga  <vargaz@gmail.com>

	* mono-compiler.h (__func__): Define this as __FUNCTION__ for MSVC.

	* mono-counters.c: Fix windows build.

Wed Mar 1 12:33:26 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-counters.h, mono-counters.c, Makefile.am: added
	API for flexible stats collection.

Tue Feb 28 13:58:50 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-compiler.h: fixed Jakub's patch to actually compile on amd64.

Tue Feb 28 11:33:40 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mono-compiler.h: patch from Jakub Jelinek to retrieve
	the tls offset without a text writable section (bug #77653).

2006-02-01  Sebastien Pouliot  <sebastien@ximian.com>

	* mono-compiler.h: Added a macro for isnormal(x) as it's not available
	in VS.NET.

2006-01-20  Zoltan Varga  <vargaz@gmail.com>

	* monobitset.h (mono_bitset_set_fast): Add more fast accessors. 

2006-01-17  Zoltan Varga  <vargaz@gmail.com>

	* monobitset.h monobitset.c: Move the mono_bitset_test_fast macro here
	 from mini.h. Also fix it after the 64 bit changes.

2006-01-15  Zoltan Varga  <vargaz@gmail.com>

	* monobitset.h monobitset.c: Use 64 bit chunks on 64 bit machines.

2006-01-04  Zoltan Varga  <vargaz@gmail.com>

	* mono-codeman.c (new_codechunk): Fix warnings.

2005-12-13  Atsushi Enomoto  <atsushi@ximian.com>

	* strtod.c : un-constified some variables to fix bug #75228.

2005-09-30 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* strenc.c: don't use the UTF16 conversion with g_convert. It returns
	the FF FE at the beginning, which is not what we expect. Now
	MONO_EXTERNAL_ENCODINGS can roundtrip and works.

2005-09-12  Zoltan Varga  <vargaz@freemail.hu>

	* mono-compiler.h (MONO_THREAD_VAR_OFFSET): Fix compilation on amd64
	with recent binutils.

Wed Sep 7 21:23:18 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c: ensure we have enough room for thunks
	with large allocations.

2005-08-27  Zoltan Varga  <vargaz@gmail.com>

	* mono-compiler.h (MONO_THREAD_VAR_OFFSET): Disable this when using
	intel icc.

	* strtod.c (Storeinc): Modify code which is miscompiled by intel icc.

Thu Aug 4 20:06:28 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c: allow room for far calls for ARM, too.

2005-07-20  Zoltan Varga  <vargaz@freemail.hu>

	* mono-compiler.h (MONO_THREAD_VAR_OFFSET): Use the nice way of
	getting the tls offsets on amd64 too.

2005-07-19  Zoltan Varga  <vargaz@freemail.hu>

	* mono-compiler.h: Add TLS offset detection for ia64.

2005-06-28  Zoltan Varga  <vargaz@freemail.hu>

	* mono-compiler.h (trunc): Define this to be floor under win32.

2005-06-13  Geoff Norton  <gnorton@customerdna.com>

	* mono-compiler.h:  Be slightly more conservative on ppc
	as this was previously causing crashes building.

2005-06-09  Duncan Mak  <duncan@novell.com>

	* *.h: Added G_BEGIN_DECLS and G_END_DECLS where appropriate to
	all public headers. Fixes #74919.

2005-05-18  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c: Align code on a 16 byte boundary on ia64.

2005-04-20  Zoltan Varga  <vargaz@freemail.hu>

	* mono-digest.h mono-sha1.c mono-md5.c: Fix some gcc 4.0 warnings.

2005-04-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mono-poll.c: windows return code translation.
	* mono-poll.h: FD_SETSIZE must be defined when compiling everything.
	Moved to configure.in.

2005-04-06 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mono-poll.[ch]: mono_poll uses poll() when available, otherwise
	implement it in terms of select().
	* Makefile.am: added new files.

2005-03-29  Sebastien Pouliot  <sebastien@ximian.com>

	* mono-compiler.h: Added defines to make it easier to compile mono and
	it's unmanaged tools using the Microsoft C compiler (VS.NET 2005).

2005-02-27  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c: Pass MAP_32BIT to mmap on amd64 to force generated
	code to have 32 bit addresses.

Fri Feb 25 14:54:19 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mono-compiler.h: amd64 can't handle local-exec in PIC libs.

Thu Feb 24 15:18:05 CET 2005 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, mono-compiler.h: added header to deal with 
	compiler-specific bugs and features.

2005-01-30  Zoltan Varga  <vargaz@freemail.hu>

	* mono-logger.c (mono_trace_is_traced): Fix comment.

	* mono-logger.h mono-logger.c (mono_trace_is_traced): New helper function.

2005-01-15  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c (new_codechunk): Initialize pagesize in the dynamic
	case as well.

2004-12-23  Ben Maurer  <bmaurer@ximian.com>

	* strtod.c: add `cosnt' to some arrays to get them on shareable pages.

Tue Dec 7 17:53:01 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c: align bsize so the returned pointer
	is aligned also for dynamic methods.

2004-10-26  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c: Fall back to malloc if MAP_ANON is not defined.

2004-09-25  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c (new_codechunk): Set malloc'ed code pages as 
	executable.

2004-09-07  Bernie Solomon  <bernard@ugsolutions.com>

	* mono-sha1.c: Remove uint32 and int32 types completely

2004-09-02  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c (new_codechunk): Remove g_assert_not_reached ().
	
	* mono-codeman.c (new_codechunk): Fix windows build.

	* mono-codeman.h mono-codeman.c: Generalize so it can be used to
	allocate code for dynamic methods (one method per code manager).

2004-07-30  Zoltan Varga  <vargaz@freemail.hu>

	* mono-logger.c (mono_trace_set_mask_string): Fix AOT tracing constant.

2004-07-28  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c (mono_code_manager_invalidate): Invalidate with
	x86 break on AMD64 too.

2004-07-23  zovarga  <vargaz@freemail.hu>

	* monobitset.c (my_g_bit_nth_msf): Add workaround for glib 2.2 bug on
	64 bit platforms.

2004-07-09  Ben Maurer  <bmaurer@ximain.com>
	
	* mono-hash.c: register gc roots

2004-07-02  Zoltan Varga  <vargaz@freemail.hu>

	* mono-logger.h mono-logger.c: Added AOT component.

2004-06-30  Zoltan Varga  <vargaz@freemail.hu>

	* strtod.c: Use gint32 for 32 bit types.

2004-06-29  Zoltan Varga  <vargaz@freemail.hu>

	* mono-sha1.c: Use gint32 for 32 types. Fixes random memory corruption
	in SHA1Transform on 64 bit systems.

2004-06-24  David Waite  <mass@akuma.org>

	* monobitset.c: change to C90-style comments from C99/C++-style 

2004-06-21  Atsushi Enomoto  <atsushi@ximian.com>

	* mono-sha1.c : close opened file in case of successful read. This
	  saves a bunch of System.Reflection Emit failures under windows.

2004-06-18  Jackson Harper  <jackson@ximian.com>

	* mono-logger.c/h: Add a trace mask option for tracing loading
	config files. A little white space love.
	
2004-06-18  Jackson Harper  <jackson@ximian.com>

	* mono-logger.c: Change default logging level to ERROR. Make sure
	that mono_trace_init is called if mono_tracev is our first trace
	statement is mono_tracev. Little indentation fix.
	
2004-05-25  Zoltan Varga  <vargaz@freemail.hu>

	* mono-codeman.c (mono_code_manager_invalidate): On x86, fill the
	memory with 0xcc (x86 break).

2004-05-02  Miguel de Icaza  <miguel@ximian.com>

	* mono-sha1.c: MacOS X defines "LITTLE_ENDIAN", you are supposed
	to test against BYTE_ORDER, and this caused trouble.  We now use
	G_BYTE_ORDER and G_LITTLE_ENDIAN.  This should fix the MacOS woes.

2004-04-26  David Waite  <mass@akuma.org>

	* mono-logger.h: remove comma from end of enumeration declaration

Fri Apr 23 11:04:33 EDT 2004 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c: macosx pretends an argument (which is ignored)
	to be -1. Make sure the thunks area is zeroed.

2004-03-11  Zoltan Varga  <vargaz@freemail.hu>

	* monobitset.c (mono_bitset_test_bulk): New function to return multiple
	bits at once.

Thu Mar 4 15:46:20 PST 2004 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c: add a define to force the use of malloc
	instead of mmap.

Tue Feb 17 21:45:12 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mono-codeman.c, mono-codeman.h: allocate extra room in memory close
	to the native code for arch where calls have a limited immediate
	displacement.

Wed Feb 11 15:26:18 CET 2004 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, mono-codeman.h, mono-codeman.c: new support code
	to deal with buffers of native code (handles exec bits and other
	details).

2004-01-22  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* strenc.c:
	(mono_unicode_from_external): UTF8 is the default, not the preferred
	encoding, ie, try MONO_EXTERNAL_ENCODINGS first. When "default_locale"
	was passed in the env. var., it always failed because we were passing
	"default_locale" to g_convert. Also fixed the byte count for non-UTF8
	conversions.
	(mono_utf8_from_external): UTF8 is the default, not the preferred one.

	Fixes bug #53166.

Thu Jan 8 19:56:08 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mono-uri.c: fixed compile problem.

2003-12-02  Bernie Solomon  <bernard@ugsolutions.com>

	* mono-math.c: fix for older C compilers and big endian machines

2003-11-12  Zoltan Varga  <vargaz@freemail.hu>

	* mono-math.h mono-math.c: New file which contains implementations of
	math functions/macros which are missing on some platforms.

2003-11-10  Dick Porter  <dick@ximian.com>

	* strenc.c: Use platform-endian UTF16

2003-10-28  Dick Porter  <dick@ximian.com>

	* strenc.h:
	* strenc.c: New files, convert text to and from unicode or utf8,
	and the user's chosen encoding.

2003-08-26  Zoltan Varga  <vargaz@freemail.hu>

	* mono-hash.h mono-hash.c (mono_g_hash_table_remap): New function used
	to remap hashtable values during a copying collection. Not used at the
	moment.
	* mono-hash.c (g_hash_node_new): Restructured to avoid the global lock
	in the common case.
	* mono-hash.c (mono_g_hash_table_new_full): Enable the optimization of
	the key function even if the client supplied g_direct_equal instead of
	NULL.

2003-08-22  Duncan Mak  <duncan@ximian.com>

	* strtod.c: 64-bit related fixes from Laurent Morichetti
	<l_m@pacbell.net>. Patch approval from Miguel.

Fri Jun 6 19:09:51 CEST 2003 Paolo Molaro <lupus@ximian.com>

	* mono-logger.h, mono-logger.c, Makefile.am: added
	selective logging code by Jerome Laban <jlaban@wanadoo.fr>.

2003-03-05  Dietmar Maurer  <dietmar@ximian.com>

	* monobitset.c (mono_bitset_set_all): impl.

Fri Sep 13 15:56:04 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* mono-digest.h, mono-sha1.c: Added mono_digest_get_public_token()
	to get the public key token from a public key.

Thu Jul 25 13:59:34 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* mono-digest.h, mono-md5.c, mono-sha1.c: MD5 and SHA1
	implementations.

Mon Jun 3 15:59:31 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* strtod.c: make __bsd_dtoa() always return malloc()ed memory.

Mon Jun 3 15:42:50 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* monobitset.c, monobitset.h: documentation and fixes from
	Dennis Haney.

Sat Jun 1 14:10:23 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* monobitset.c: fix my screwup pointed out by Lawrence Pit
	(loz@cable.a2000.nl).

Fri May 31 15:34:18 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* monobitset.c, monobitset.h: fixes. added mono_bitset_foreach().

Wed May 22 12:42:06 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* monobitset.c: use our own bit_nth_lsf since the glib one is buggy.
	Add more tests. mono_bitset_find_first (set, -1) will work correctly
	now.

2002-05-09  Dietmar Maurer  <dietmar@ximian.com>

	* monobitset.c: use memcmp instead of memcpy

Thu May 9 17:23:17 CEST 2002 Paolo Molaro <lupus@ximian.com>

	* monobitset.c, monibitset.h: bit set data structure.
	Not included in the build yet because the jit has some symbol clashes
	with it.

Mon Mar 25 12:50:53 CET 2002 Paolo Molaro <lupus@ximian.com>

	* First checkin: libmonoutils is meant to hold some utility
	data structures and bits that are usefult to the rest of the project
	and don't require metadata/runtime support.
	mono-hash is a GC-safe hash table: i.e. you can store GC-allocated
	data in it.

